package com.mycompany.app.db;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.DriverManager;

import junit.framework.TestCase;

import org.dbunit.Assertion;
import org.dbunit.database.DatabaseConnection;
import org.dbunit.database.IDatabaseConnection;
import org.dbunit.dataset.IDataSet;
import org.dbunit.dataset.ITable;
import org.dbunit.dataset.filter.DefaultColumnFilter;
import org.dbunit.dataset.xml.FlatXmlDataSet;
import org.dbunit.operation.DatabaseOperation;

import com.smtpunit.server.SmtpServer;

public class MemberTest extends TestCase {
    private String dbUrl = [f[^x[XurlZbg܂];

    private String dbUid = [f[^x[X[U];

    private String dbPasswd = [f[^x[X[U[pX[h];
    private IDatabaseConnection dbunitConn = null;

    public MemberTest(String arg0) {
        super(arg0);
    }
    protected void setUp() throws Exception {
        super.setUp();
        dbunitConn = new DatabaseConnection(this.getConnection());
    }

    protected void tearDown() throws Exception {
        super.tearDown();
        dbunitConn.close();
    }

    private Connection getConnection() throws Exception {
        //JdbcRlNV̐
        Class.forName("org.postgresql.Driver");
        Connection connection = null;
        connection = DriverManager.getConnection(dbUrl, dbUid, dbPasswd);
        connection.setAutoCommit(false);
        connection.setTransactionIsolation(Connection.TRANSACTION_READ_COMMITTED);
        return connection;
    }

    /*
     * ̍XVeXg
     */
    public void testUpdateMember() throws Exception {
        String dtdFileName = "./src/test/dataset/sample_table.dtd";
        String loadXmlFileName = "./src/test/dataset/updateSampleDS.xml";
        String expectedXmlFileName = "./src/test/dataset/expectedSampleUpdateDS.xml";
        // XVpf[^̑}MEMBER̃NA
        FileInputStream dtdfis = new FileInputStream(dtdFileName);
        FileInputStream fis = new FileInputStream(loadXmlFileName);
        FlatXmlDataSet dataSet = new FlatXmlDataSet(fis, dtdfis);

        DatabaseOperation.CLEAN_INSERT.execute(dbunitConn, dataSet);
        dbunitConn.getConnection().commit();

        //eXgΏۂ̑Jn
        Connection conn = getConnection();
        Member member = new Member(conn);
        //f[^̍XV
        member.updateMember("0", "aaa@aaa.co.jp", "Z0", "03-1234-5670",1000);
        //eXgΏۂ̑I
        conn.close();
        // f[^̌
        FileInputStream dsfis = new FileInputStream(expectedXmlFileName);
        IDataSet expectedDataSet = new FlatXmlDataSet(dsfis);

        ITable expectedTable = expectedDataSet.getTable("member");
        IDataSet databaseDataSet = dbunitConn.createDataSet();
        ITable actualTable = databaseDataSet.getTable("member");

        //ؗpf[^Œ`JŃtB^[f[^x[X̃f[^o
        ITable filteredTable = DefaultColumnFilter.includedColumnsTable(
                actualTable, expectedTable.getTableMetaData().getColumns());
        // f[^̌
        // ҂f[^ƃf[^x[X璊oʂŌ؂
        Assertion.assertEquals(expectedTable, filteredTable);
    }
}